/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface ENSRegistryInterface extends ethers.utils.Interface {
  functions: {
    "setRecord(bytes32,address,address,uint64)": FunctionFragment;
    "setSubnodeRecord(bytes32,bytes32,address,address,uint64)": FunctionFragment;
    "setOwner(bytes32,address)": FunctionFragment;
    "setSubnodeOwner(bytes32,bytes32,address)": FunctionFragment;
    "setResolver(bytes32,address)": FunctionFragment;
    "setTTL(bytes32,uint64)": FunctionFragment;
    "setApprovalForAll(address,bool)": FunctionFragment;
    "owner(bytes32)": FunctionFragment;
    "resolver(bytes32)": FunctionFragment;
    "ttl(bytes32)": FunctionFragment;
    "recordExists(bytes32)": FunctionFragment;
    "isApprovedForAll(address,address)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "setRecord",
    values: [BytesLike, string, string, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "setSubnodeRecord",
    values: [BytesLike, BytesLike, string, string, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "setOwner",
    values: [BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "setSubnodeOwner",
    values: [BytesLike, BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "setResolver",
    values: [BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "setTTL",
    values: [BytesLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "setApprovalForAll",
    values: [string, boolean]
  ): string;
  encodeFunctionData(functionFragment: "owner", values: [BytesLike]): string;
  encodeFunctionData(functionFragment: "resolver", values: [BytesLike]): string;
  encodeFunctionData(functionFragment: "ttl", values: [BytesLike]): string;
  encodeFunctionData(
    functionFragment: "recordExists",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "isApprovedForAll",
    values: [string, string]
  ): string;

  decodeFunctionResult(functionFragment: "setRecord", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setSubnodeRecord",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setOwner", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setSubnodeOwner",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setResolver",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setTTL", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setApprovalForAll",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "resolver", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "ttl", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "recordExists",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isApprovedForAll",
    data: BytesLike
  ): Result;

  events: {
    "NewOwner(bytes32,bytes32,address)": EventFragment;
    "Transfer(bytes32,address,address)": EventFragment;
    "NewResolver(bytes32,address)": EventFragment;
    "NewTTL(bytes32,uint64)": EventFragment;
    "ApprovalForAll(address,address,bool)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "NewOwner"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Transfer"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "NewResolver"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "NewTTL"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ApprovalForAll"): EventFragment;
}

export type NewOwnerEvent = TypedEvent<
  [string, string, string] & { node: string; label: string; owner: string }
>;

export type TransferEvent = TypedEvent<
  [string, string, string] & { node: string; owner: string; owner: string }
>;

export type NewResolverEvent = TypedEvent<
  [string, string] & { node: string; resolver: string }
>;

export type NewTTLEvent = TypedEvent<
  [string, BigNumber] & { node: string; ttl: BigNumber }
>;

export type ApprovalForAllEvent = TypedEvent<
  [string, string, boolean] & {
    owner: string;
    operator: string;
    approved: boolean;
  }
>;

export class ENSRegistry extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: ENSRegistryInterface;

  functions: {
    /**
     * Sets the record for a node.
     * @param node The node to update.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setRecord(
      node: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    /**
     * Sets the record for a subnode.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setSubnodeRecord(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    /**
     * Transfers ownership of a node to a new address. May only be called by the current owner of the node.
     * @param node The node to transfer ownership of.
     * @param owner The address of the new owner.
     */
    setOwner(
      node: BytesLike,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    /**
     * Transfers ownership of a subnode keccak256(node, label) to a new address. May only be called by the owner of the parent node.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     */
    setSubnodeOwner(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    /**
     * Sets the resolver address for the specified node.
     * @param node The node to update.
     * @param resolver The address of the resolver.
     */
    setResolver(
      node: BytesLike,
      resolver: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    /**
     * Sets the TTL for the specified node.
     * @param node The node to update.
     * @param ttl The TTL in seconds.
     */
    setTTL(
      node: BytesLike,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    /**
     * Enable or disable approval for a third party ("operator") to manage all of `msg.sender`'s ENS records. Emits the ApprovalForAll event.
     * @param approved True if the operator is approved, false to revoke approval.
     * @param operator Address to add to the set of authorized operators.
     */
    setApprovalForAll(
      operator: string,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    /**
     * Returns the address that owns the specified node.
     * @param node The specified node.
     * @returns address of the owner.
     */
    owner(node: BytesLike, overrides?: CallOverrides): Promise<[string]>;

    /**
     * Returns the address of the resolver for the specified node.
     * @param node The specified node.
     * @returns address of the resolver.
     */
    resolver(node: BytesLike, overrides?: CallOverrides): Promise<[string]>;

    /**
     * Returns the TTL of a node, and any records associated with it.
     * @param node The specified node.
     * @returns ttl of the node.
     */
    ttl(node: BytesLike, overrides?: CallOverrides): Promise<[BigNumber]>;

    /**
     * Returns whether a record has been imported to the registry.
     * @param node The specified node.
     * @returns Bool if record exists
     */
    recordExists(
      node: BytesLike,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    /**
     * Query if an address is an authorized operator for another address.
     * @param operator The address that acts on behalf of the owner.
     * @param owner The address that owns the records.
     * @returns True if `operator` is an approved operator for `owner`, false otherwise.
     */
    isApprovedForAll(
      owner: string,
      operator: string,
      overrides?: CallOverrides
    ): Promise<[boolean]>;
  };

  /**
   * Sets the record for a node.
   * @param node The node to update.
   * @param owner The address of the new owner.
   * @param resolver The address of the resolver.
   * @param ttl The TTL in seconds.
   */
  setRecord(
    node: BytesLike,
    owner: string,
    resolver: string,
    ttl: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  /**
   * Sets the record for a subnode.
   * @param label The hash of the label specifying the subnode.
   * @param node The parent node.
   * @param owner The address of the new owner.
   * @param resolver The address of the resolver.
   * @param ttl The TTL in seconds.
   */
  setSubnodeRecord(
    node: BytesLike,
    label: BytesLike,
    owner: string,
    resolver: string,
    ttl: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  /**
   * Transfers ownership of a node to a new address. May only be called by the current owner of the node.
   * @param node The node to transfer ownership of.
   * @param owner The address of the new owner.
   */
  setOwner(
    node: BytesLike,
    owner: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  /**
   * Transfers ownership of a subnode keccak256(node, label) to a new address. May only be called by the owner of the parent node.
   * @param label The hash of the label specifying the subnode.
   * @param node The parent node.
   * @param owner The address of the new owner.
   */
  setSubnodeOwner(
    node: BytesLike,
    label: BytesLike,
    owner: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  /**
   * Sets the resolver address for the specified node.
   * @param node The node to update.
   * @param resolver The address of the resolver.
   */
  setResolver(
    node: BytesLike,
    resolver: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  /**
   * Sets the TTL for the specified node.
   * @param node The node to update.
   * @param ttl The TTL in seconds.
   */
  setTTL(
    node: BytesLike,
    ttl: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  /**
   * Enable or disable approval for a third party ("operator") to manage all of `msg.sender`'s ENS records. Emits the ApprovalForAll event.
   * @param approved True if the operator is approved, false to revoke approval.
   * @param operator Address to add to the set of authorized operators.
   */
  setApprovalForAll(
    operator: string,
    approved: boolean,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  /**
   * Returns the address that owns the specified node.
   * @param node The specified node.
   * @returns address of the owner.
   */
  owner(node: BytesLike, overrides?: CallOverrides): Promise<string>;

  /**
   * Returns the address of the resolver for the specified node.
   * @param node The specified node.
   * @returns address of the resolver.
   */
  resolver(node: BytesLike, overrides?: CallOverrides): Promise<string>;

  /**
   * Returns the TTL of a node, and any records associated with it.
   * @param node The specified node.
   * @returns ttl of the node.
   */
  ttl(node: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;

  /**
   * Returns whether a record has been imported to the registry.
   * @param node The specified node.
   * @returns Bool if record exists
   */
  recordExists(node: BytesLike, overrides?: CallOverrides): Promise<boolean>;

  /**
   * Query if an address is an authorized operator for another address.
   * @param operator The address that acts on behalf of the owner.
   * @param owner The address that owns the records.
   * @returns True if `operator` is an approved operator for `owner`, false otherwise.
   */
  isApprovedForAll(
    owner: string,
    operator: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  callStatic: {
    /**
     * Sets the record for a node.
     * @param node The node to update.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setRecord(
      node: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    /**
     * Sets the record for a subnode.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setSubnodeRecord(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    /**
     * Transfers ownership of a node to a new address. May only be called by the current owner of the node.
     * @param node The node to transfer ownership of.
     * @param owner The address of the new owner.
     */
    setOwner(
      node: BytesLike,
      owner: string,
      overrides?: CallOverrides
    ): Promise<void>;

    /**
     * Transfers ownership of a subnode keccak256(node, label) to a new address. May only be called by the owner of the parent node.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     */
    setSubnodeOwner(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      overrides?: CallOverrides
    ): Promise<string>;

    /**
     * Sets the resolver address for the specified node.
     * @param node The node to update.
     * @param resolver The address of the resolver.
     */
    setResolver(
      node: BytesLike,
      resolver: string,
      overrides?: CallOverrides
    ): Promise<void>;

    /**
     * Sets the TTL for the specified node.
     * @param node The node to update.
     * @param ttl The TTL in seconds.
     */
    setTTL(
      node: BytesLike,
      ttl: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    /**
     * Enable or disable approval for a third party ("operator") to manage all of `msg.sender`'s ENS records. Emits the ApprovalForAll event.
     * @param approved True if the operator is approved, false to revoke approval.
     * @param operator Address to add to the set of authorized operators.
     */
    setApprovalForAll(
      operator: string,
      approved: boolean,
      overrides?: CallOverrides
    ): Promise<void>;

    /**
     * Returns the address that owns the specified node.
     * @param node The specified node.
     * @returns address of the owner.
     */
    owner(node: BytesLike, overrides?: CallOverrides): Promise<string>;

    /**
     * Returns the address of the resolver for the specified node.
     * @param node The specified node.
     * @returns address of the resolver.
     */
    resolver(node: BytesLike, overrides?: CallOverrides): Promise<string>;

    /**
     * Returns the TTL of a node, and any records associated with it.
     * @param node The specified node.
     * @returns ttl of the node.
     */
    ttl(node: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;

    /**
     * Returns whether a record has been imported to the registry.
     * @param node The specified node.
     * @returns Bool if record exists
     */
    recordExists(node: BytesLike, overrides?: CallOverrides): Promise<boolean>;

    /**
     * Query if an address is an authorized operator for another address.
     * @param operator The address that acts on behalf of the owner.
     * @param owner The address that owns the records.
     * @returns True if `operator` is an approved operator for `owner`, false otherwise.
     */
    isApprovedForAll(
      owner: string,
      operator: string,
      overrides?: CallOverrides
    ): Promise<boolean>;
  };

  filters: {
    "NewOwner(bytes32,bytes32,address)"(
      node?: BytesLike | null,
      label?: BytesLike | null,
      owner?: null
    ): TypedEventFilter<
      [string, string, string],
      { node: string; label: string; owner: string }
    >;

    NewOwner(
      node?: BytesLike | null,
      label?: BytesLike | null,
      owner?: null
    ): TypedEventFilter<
      [string, string, string],
      { node: string; label: string; owner: string }
    >;

    "Transfer(bytes32,address,address)"(
      node?: BytesLike | null,
      owner?: null,
      owner?: null
    ): TypedEventFilter<
      [string, string, string],
      { node: string; owner: string; owner: string }
    >;

    Transfer(
      node?: BytesLike | null,
      owner?: null,
      owner?: null
    ): TypedEventFilter<
      [string, string, string],
      { node: string; owner: string; owner: string }
    >;

    "NewResolver(bytes32,address)"(
      node?: BytesLike | null,
      resolver?: null
    ): TypedEventFilter<[string, string], { node: string; resolver: string }>;

    NewResolver(
      node?: BytesLike | null,
      resolver?: null
    ): TypedEventFilter<[string, string], { node: string; resolver: string }>;

    "NewTTL(bytes32,uint64)"(
      node?: BytesLike | null,
      ttl?: null
    ): TypedEventFilter<[string, BigNumber], { node: string; ttl: BigNumber }>;

    NewTTL(
      node?: BytesLike | null,
      ttl?: null
    ): TypedEventFilter<[string, BigNumber], { node: string; ttl: BigNumber }>;

    "ApprovalForAll(address,address,bool)"(
      owner?: string | null,
      operator?: string | null,
      approved?: null
    ): TypedEventFilter<
      [string, string, boolean],
      { owner: string; operator: string; approved: boolean }
    >;

    ApprovalForAll(
      owner?: string | null,
      operator?: string | null,
      approved?: null
    ): TypedEventFilter<
      [string, string, boolean],
      { owner: string; operator: string; approved: boolean }
    >;
  };

  estimateGas: {
    /**
     * Sets the record for a node.
     * @param node The node to update.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setRecord(
      node: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    /**
     * Sets the record for a subnode.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setSubnodeRecord(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    /**
     * Transfers ownership of a node to a new address. May only be called by the current owner of the node.
     * @param node The node to transfer ownership of.
     * @param owner The address of the new owner.
     */
    setOwner(
      node: BytesLike,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    /**
     * Transfers ownership of a subnode keccak256(node, label) to a new address. May only be called by the owner of the parent node.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     */
    setSubnodeOwner(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    /**
     * Sets the resolver address for the specified node.
     * @param node The node to update.
     * @param resolver The address of the resolver.
     */
    setResolver(
      node: BytesLike,
      resolver: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    /**
     * Sets the TTL for the specified node.
     * @param node The node to update.
     * @param ttl The TTL in seconds.
     */
    setTTL(
      node: BytesLike,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    /**
     * Enable or disable approval for a third party ("operator") to manage all of `msg.sender`'s ENS records. Emits the ApprovalForAll event.
     * @param approved True if the operator is approved, false to revoke approval.
     * @param operator Address to add to the set of authorized operators.
     */
    setApprovalForAll(
      operator: string,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    /**
     * Returns the address that owns the specified node.
     * @param node The specified node.
     * @returns address of the owner.
     */
    owner(node: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;

    /**
     * Returns the address of the resolver for the specified node.
     * @param node The specified node.
     * @returns address of the resolver.
     */
    resolver(node: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;

    /**
     * Returns the TTL of a node, and any records associated with it.
     * @param node The specified node.
     * @returns ttl of the node.
     */
    ttl(node: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;

    /**
     * Returns whether a record has been imported to the registry.
     * @param node The specified node.
     * @returns Bool if record exists
     */
    recordExists(
      node: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    /**
     * Query if an address is an authorized operator for another address.
     * @param operator The address that acts on behalf of the owner.
     * @param owner The address that owns the records.
     * @returns True if `operator` is an approved operator for `owner`, false otherwise.
     */
    isApprovedForAll(
      owner: string,
      operator: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    /**
     * Sets the record for a node.
     * @param node The node to update.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setRecord(
      node: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    /**
     * Sets the record for a subnode.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     * @param resolver The address of the resolver.
     * @param ttl The TTL in seconds.
     */
    setSubnodeRecord(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      resolver: string,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    /**
     * Transfers ownership of a node to a new address. May only be called by the current owner of the node.
     * @param node The node to transfer ownership of.
     * @param owner The address of the new owner.
     */
    setOwner(
      node: BytesLike,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    /**
     * Transfers ownership of a subnode keccak256(node, label) to a new address. May only be called by the owner of the parent node.
     * @param label The hash of the label specifying the subnode.
     * @param node The parent node.
     * @param owner The address of the new owner.
     */
    setSubnodeOwner(
      node: BytesLike,
      label: BytesLike,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    /**
     * Sets the resolver address for the specified node.
     * @param node The node to update.
     * @param resolver The address of the resolver.
     */
    setResolver(
      node: BytesLike,
      resolver: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    /**
     * Sets the TTL for the specified node.
     * @param node The node to update.
     * @param ttl The TTL in seconds.
     */
    setTTL(
      node: BytesLike,
      ttl: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    /**
     * Enable or disable approval for a third party ("operator") to manage all of `msg.sender`'s ENS records. Emits the ApprovalForAll event.
     * @param approved True if the operator is approved, false to revoke approval.
     * @param operator Address to add to the set of authorized operators.
     */
    setApprovalForAll(
      operator: string,
      approved: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    /**
     * Returns the address that owns the specified node.
     * @param node The specified node.
     * @returns address of the owner.
     */
    owner(
      node: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    /**
     * Returns the address of the resolver for the specified node.
     * @param node The specified node.
     * @returns address of the resolver.
     */
    resolver(
      node: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    /**
     * Returns the TTL of a node, and any records associated with it.
     * @param node The specified node.
     * @returns ttl of the node.
     */
    ttl(
      node: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    /**
     * Returns whether a record has been imported to the registry.
     * @param node The specified node.
     * @returns Bool if record exists
     */
    recordExists(
      node: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    /**
     * Query if an address is an authorized operator for another address.
     * @param operator The address that acts on behalf of the owner.
     * @param owner The address that owns the records.
     * @returns True if `operator` is an approved operator for `owner`, false otherwise.
     */
    isApprovedForAll(
      owner: string,
      operator: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
