'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var index = require('./index-717c8606.js');
var didResolverInterface = require('@ew-did-registry/did-resolver-interface');
var credentialGovernance = require('@energyweb/credential-governance');
require('ethers');
require('base64url');
require('@walletconnect/ethereum-provider');
require('@ew-did-registry/did');
require('@ew-did-registry/did-ethr-resolver');
require('@energyweb/ekc');
require('@ethersproject/properties');
require('ethers/lib/utils');
require('@metamask/detect-provider');
require('@walletconnect/client');
require('@walletconnect/qrcode-modal');
require('@gnosis.pm/safe-apps-provider');
require('multiformats/cid');
require('@ew-did-registry/keys');
require('@ew-did-registry/jwt');
require('@ew-did-registry/proxyidentity');
require('@ew-did-registry/did-document');
require('@ew-did-registry/did-ipfs-store');
require('@ew-did-registry/claims');
require('ts-interface-checker');
require('@ew-did-registry/credentials-interface');
require('lodash');
require('nats.ws');
require('axios');
require('qs');
require('set-cookie-parser');
require('axios-retry');
require('siwe');
require('eth-ens-namehash');
require('jsonwebtoken');
require('uuid');
require('@energyweb/onchain-claims');
require('@energyweb/vc-verification');
require('@ew-did-registry/revocation');
require('@sphereon/pex');



Object.defineProperty(exports, 'AssetHistoryEventType', {
	enumerable: true,
	get: function () { return index.AssetHistoryEventType; }
});
exports.AssetNotExist = index.AssetNotExist;
exports.AssetsService = index.AssetsService;
exports.AuthService = index.AuthService;
exports.CacheClient = index.CacheClient;
exports.ChangeOwnershipNotPossibleError = index.ChangeOwnershipNotPossibleError;
Object.defineProperty(exports, 'ClaimEventType', {
	enumerable: true,
	get: function () { return index.ClaimEventType; }
});
exports.ClaimsService = index.ClaimsService;
exports.ConsoleLogger = index.ConsoleLogger;
exports.DEFAULT_AUTH_STATUS_PATH = index.DEFAULT_AUTH_STATUS_PATH;
exports.DeletingNamespaceNotPossibleError = index.DeletingNamespaceNotPossibleError;
exports.DidRegistry = index.DidRegistry;
exports.DomainsService = index.DomainsService;
exports.ENSOwnerNotValidAddressError = index.ENSOwnerNotValidAddressError;
exports.ENSTypeNotSupportedError = index.ENSTypeNotSupportedError;
Object.defineProperty(exports, 'ERROR_MESSAGES', {
	enumerable: true,
	get: function () { return index.ERROR_MESSAGES; }
});
exports.EkcSigner = index.EkcSigner;
Object.defineProperty(exports, 'ExecutionEnvironment', {
	enumerable: true,
	get: function () { return index.ExecutionEnvironment; }
});
exports.ILogger = index.ILogger;
exports.IS_ETH_SIGNER = index.IS_ETH_SIGNER;
exports.InterfaceNotSatisfied = index.InterfaceNotSatisfied;
Object.defineProperty(exports, 'LogLevel', {
	enumerable: true,
	get: function () { return index.LogLevel; }
});
exports.MalformedDIDError = index.MalformedDIDError;
Object.defineProperty(exports, 'MessagingMethod', {
	enumerable: true,
	get: function () { return index.MessagingMethod; }
});
exports.MessagingService = index.MessagingService;
exports.MethodNotAvailableInNodeEnvError = index.MethodNotAvailableInNodeEnvError;
exports.NODE_FIELDS_KEY = index.NODE_FIELDS_KEY;
Object.defineProperty(exports, 'NamespaceType', {
	enumerable: true,
	get: function () { return index.NamespaceType; }
});
exports.NotAuthorizedIssuer = index.NotAuthorizedIssuer;
Object.defineProperty(exports, 'Order', {
	enumerable: true,
	get: function () { return index.Order; }
});
exports.PUBLIC_KEY = index.PUBLIC_KEY;
Object.defineProperty(exports, 'ProviderEvent', {
	enumerable: true,
	get: function () { return index.ProviderEvent; }
});
Object.defineProperty(exports, 'ProviderType', {
	enumerable: true,
	get: function () { return index.ProviderType; }
});
Object.defineProperty(exports, 'RegistrationTypes', {
	enumerable: true,
	get: function () { return index.RegistrationTypes; }
});
Object.defineProperty(exports, 'SearchType', {
	enumerable: true,
	get: function () { return index.SearchType; }
});
exports.SignerService = index.SignerService;
exports.SiweAuthTokensClient = index.SiweAuthTokensClient;
Object.defineProperty(exports, 'StakeStatus', {
	enumerable: true,
	get: function () { return index.StakeStatus; }
});
exports.StakingFactoryService = index.StakingFactoryService;
exports.StakingPoolService = index.StakingPoolService;
exports.VOLTA_CHAIN_ID = index.VOLTA_CHAIN_ID;
exports.VerifiableCredentialsServiceBase = index.VerifiableCredentialsServiceBase;
exports.addSupportedDID = index.addSupportedDID;
exports.agreement_type_hash = index.agreement_type_hash;
exports.cacheConfigs = index.cacheConfigs;
exports.castToV2 = index.castToV2;
exports.chainConfigs = index.chainConfigs;
exports.compareDID = index.compareDID;
exports.createWalletConnectProvider = index.createWalletConnectProvider;
exports.defaultAzureProxyUrl = index.defaultAzureProxyUrl;
exports.defaultBridgeUrl = index.defaultBridgeUrl;
exports.defaultKmsServerUrl = index.defaultKmsServerUrl;
exports.didPattern = index.didPattern;
exports.emptyAddress = index.emptyAddress;
exports.erc712_type_hash = index.erc712_type_hash;
exports.eternityTimestamp = index.eternityTimestamp;
exports.executionEnvironment = index.executionEnvironment;
exports.fromGnosis = index.fromGnosis;
exports.fromKms = index.fromKms;
exports.fromMetaMask = index.fromMetaMask;
exports.fromPrivateKey = index.fromPrivateKey;
exports.fromWalletConnectMetamask = index.fromWalletConnectMetamask;
exports.getLogger = index.getLogger;
exports.getMessagingConfig = index.getMessagingConfig;
exports.getVerifiableCredentialsService = index.getVerifiableCredentialsService;
exports.init = index.init;
exports.initWithEKC = index.initWithEKC;
exports.initWithGnosis = index.initWithGnosis;
exports.initWithKms = index.initWithKms;
exports.initWithMetamask = index.initWithMetamask;
exports.initWithPrivateKeySigner = index.initWithPrivateKeySigner;
exports.initWithWalletConnect = index.initWithWalletConnect;
exports.isClaimService = index.isClaimService;
exports.isMetamaskExtensionPresent = index.isMetamaskExtensionPresent;
exports.isRoleCredential = index.isRoleCredential;
exports.isValidDID = index.isValidDID;
exports.proof_type_hash = index.proof_type_hash;
exports.readyToBeRegisteredOnchain = index.readyToBeRegisteredOnchain;
exports.setCacheConfig = index.setCacheConfig;
exports.setChainConfig = index.setChainConfig;
exports.setLogger = index.setLogger;
exports.setMessagingConfig = index.setMessagingConfig;
exports.statusList2021CredentialEIP712Types = index.statusList2021CredentialEIP712Types;
exports.supportedDIDMethods = index.supportedDIDMethods;
exports.typedMsgPrefix = index.typedMsgPrefix;
exports.validateRoleCredentialSubject = index.validateRoleCredentialSubject;
exports.verifiableCredentialEIP712Types = index.verifiableCredentialEIP712Types;
exports.verifiablePresentationEIP712Types = index.verifiablePresentationEIP712Types;
exports.verifiablePresentationWithCredentialEIP712Types = index.verifiablePresentationWithCredentialEIP712Types;
Object.defineProperty(exports, 'DIDAttribute', {
	enumerable: true,
	get: function () { return didResolverInterface.DIDAttribute; }
});
Object.defineProperty(exports, 'PubKeyType', {
	enumerable: true,
	get: function () { return didResolverInterface.PubKeyType; }
});
Object.defineProperty(exports, 'PreconditionType', {
	enumerable: true,
	get: function () { return credentialGovernance.PreconditionType; }
});
